/*  FreeNote for Sharp SLA300, B500, C7x0, C860 Linux PDA
	Copyright (C) 2003-2005 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
2005/02/27 FreeNote 1.11.10pre
EPDF̏o͌`ꕔύX
EC|[g̃oOfix

2005/01/04 FreeNote 1.11.6pre
EJ[u[hłW̎悤ɐ`GWP
2004/10/17 FreeNote 1.10.0[X
2004/02/14 ver 1.7.2pre
E@\ǉ
*/
#ifndef FNFINDDIALOG_H
#define FNFINDDIALOG_H
#include "fnfinddialogbase.h"
#include "fnpolygon.h"
#include "fncanvas.h"

class FNFindDialog : public FNFindDialogBase
{ 
    Q_OBJECT

signals:
	void originChanged(int x, int y);
	void resetOrigin();
public:
    FNFindDialog( QWidget* parent = 0, const char* name = 0);
    ~FNFindDialog();
    void setElements(FNLayerList& v);
public slots:
    virtual void findPrev();
    virtual void findNext();
private:
	int _idx;
	FNPolygonList _texts;
};
#endif // FNFINDDIALOG_H
