/*  FreeNote for Sharp SLA300, B500, C7x0, C860 Linux PDA
	Copyright (C) 2003-2005 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
2005/02/27 FreeNote 1.11.10pre
EPDF̏o͌`ꕔύX
EC|[g̃oOfix

2004/10/17 FreeNote 1.10.0[X
*/
#ifndef FNTEXTDIALOG_H
#define FNTEXTDIALOG_H
#include "fntextdialogbase.h"
#include <qpen.h>
#include <qfont.h>
#include "fncolordialog.h"


class FNTextDialog : public FNTextDialogBase
{ 
    Q_OBJECT

public:
    FNTextDialog(const QString& fontname, FNColorDialog* dlg, QWidget* parent = 0, const char* name = 0);
    ~FNTextDialog();
    void setPen(const QPen& pen);
    const QPen& pen() const;

public slots:
    virtual void choose(int v);
    virtual void btnColor_Clicked();
	virtual void changeColor(QRgb c);
private:
	QPen _pen;
	FNColorDialog* _colorSelector;
};

#endif // FNTEXTDIALOG_H
