/*  FreeNote for Sharp SLA300, B500, C7x0 Linux PDA
	Copyright (C) 2003 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
2004/06/19 ver 1.9.2pre
Ec[@\ǉ

2004/02/26 ver 1.9.0pre
EC|[g@\
 
2004/02/16 ver 1.7.3pre
EҏW@\

2004/02/14 ver 1.7.2pre
E@\ǉ

2003/11/19 FreeNote 1.5.5pre
EȐ`pdetailIvV̔p~

2003/11/16 FreeNote 1.5.2pre
EOς̑SʍV
E`@\̃IvVǉ

2003/11/12 FreeNote 1.5.1pre
EMaximized{^ǉ
EDraw{^폜

2003/09/01-03 ver 1.3.3pre
EXN[̉
EUse all quadrant(Sیgp)j[ǉ

2003/08/20-23 FreeNote 1.3.0pre
ECR{^ǉ
EXN[[h̕ۑ
EKChԂ̕ۑ

2003/08/15 FreeNote 1.2.1J
Eۑ̃oOC
E_CAO̎
EPNGt@Cւ̏o

2003/08/15 FreeNote 1.2J
EIvVǉ
EXN[KCh
EFreet@C֘At
EACR̕ύX
*/
#ifndef FNOPTIONDIALOG_H
#define FNOPTIONDIALOG_H
#include <qdialog.h>
#include <qlist.h>
#include <qpushbutton.h>
#include <qcombobox.h>
//#include "fncanvas.h"
#include "fniconset.h"
#include "fnoptiondialogbase.h" //<-QTfUCi[ɂ莩ꂽNXB
#include "fnoptiondata.h"
#include "fncolordialog.h"

class FNOptionDialog : public FNOptionDialogBase {
	Q_OBJECT
public:
	FNOptionDialog(QWidget* parent, const FNOptionData& options);
	virtual ~FNOptionDialog();
	const FNOptionData& options() const;
signals:
	void done();
protected slots:
	virtual void accept() {
		emit done();
	};
	virtual void reject() {
		emit done();
	};
    virtual void CRIconToggled(bool);
    virtual void boldIconToggled(bool);
    virtual void clearIconToggled(bool);
    virtual void colorIconToggled(bool);
    virtual void eraserLChanged(int);
    virtual void eraserSChanged(int);
    virtual void exportIconToggled(bool);
    virtual void exportPNGIconToggled(bool);
    virtual void gridSizeChanged(int);
    virtual void guideIconToggled(bool);
    virtual void h_stepChanged(int);
    virtual void loadIconToggled(bool);
    virtual void marginChanged(int);
    virtual void maximizedIconToggled(bool);
    virtual void newIconToggled(bool);
    virtual void findIconToggled(bool);
    virtual void phase1Changed(int);
    virtual void phase2Changed(int);
    virtual void saveIconToggled(bool);
    virtual void timingChanged(int);
    virtual void copyIconToggled(bool);
    virtual void pasteIconToggled(bool);
    virtual void importIconToggled(bool);
    virtual void layerIconToggled(bool);
    virtual void undoIconToggled(bool);
    virtual void redoIconToggled(bool);
    virtual void colorRevisionToggled(bool);
    virtual void v_stepChanged(int);
    virtual void zoomIconToggled(bool);
    virtual void quitQuicklyToggled(bool);
    virtual void encodeActivated(const QString&);
    virtual void fontActivated(const QString&);
    virtual void lMvAIconToggled(bool);
    virtual void lMvBIconToggled(bool);
    virtual void lAddIconToggled(bool);
    virtual void BtnLineColClicked();
    virtual void BtnBrushColClicked();
    virtual void BtnFrameColClicked();
    virtual void BtnRulerColClicked();
    virtual void BtnGuideColClicked();
    virtual void BtnGridColClicked();
    virtual bool ColorDialogPopup(const QColor& c);
	virtual const QColor& getButtonColor(QFrame* btn);
	virtual void setButtonColor(QFrame* btn, const QColor& c);
private:
	FNOptionData _options;
	FNColorDialog* _colorSelector;
};
#endif //FNOPTIONDIALOG_H
